﻿using C1.Blazor.Grid;
using C1.Blazor.Core;
using Microsoft.JSInterop;
using Microsoft.AspNetCore.Components;
using System.IO;
using Microsoft.AspNetCore.Components.Rendering;
using FlexGridIntro.Client.Shared;

namespace FlexGridIntro.Client.Models
{
    public class MyGridHyperLinkColumn: GridHyperlinkColumn
    {
        protected override RenderFragment GetCellContentRenderFragment(GridCellType cellType, GridRow row)
        {
            if(cellType == GridCellType.Cell)
            {   
                var item = row.DataItem;
                var content = item.GetType().GetProperty(this.ContentBinding).GetValue(item);
                var link = item.GetType().GetProperty(this.Binding).GetValue(item);
                //RenderTreeBuilder builder = new RenderTreeBuilder();
                //builder.OpenElement(0, "a");
                //builder.CloseComponent();
                //builder.AddAttribute(0,"href",link);
                ////builder.AddAttribute(0, "href", content);
                //builder.AddContent(0, content);

                RenderFragment anchor = builder =>
                {
                    builder.OpenComponent<Anchor>(1);
                    builder.AddAttribute(2, "Link", link);
                    builder.AddAttribute(3, "Content", content);
                    builder.CloseComponent();
                };
                return anchor;
            }
            return base.GetCellContentRenderFragment(cellType, row);
        }

        private RenderFragment AddContent(string content) => builder =>
        {
            builder.AddContent(1, content);
        };
    }
    public class MyGrid : FlexGrid
    {
        [Inject]
        private IJSRuntime jSRuntime { get; set; }

        public MyGrid() : base()
        {
            
        }

        
      
        //public override void Copy()
        //{
        //    GridCellRange gridCellRange = ((base.SelectionMode == GridSelectionMode.None) ? CursorRange : Selection);
        //    if (!(gridCellRange == null))
        //    {
        //        var text = "";
                
        //        for (int j = gridCellRange.Row; j <= gridCellRange.Row2; j++)
        //        {
        //            var _dataItem = this.Rows[j].DataItem;
        //            for (int i = gridCellRange.Column; i <= gridCellRange.Column2; i++)
        //            {
        //                var _col = this.Columns[i];
        //                if(_col.GetType()== typeof(GridHyperlinkColumn))
        //                {
        //                    text += _dataItem.GetType().GetProperty(((_col as GridHyperlinkColumn).ContentBinding)).GetValue(_dataItem)+"\t";
        //                }
        //                else
        //                {
        //                    text += this.Cells[j, i]+"\t";
        //                }
        //            }
        //        }
        //        // custom Content to Clipboard 
        //         this.jSRuntime.InvokeVoidAsync("navigator.clipboard.writeText", text);
        //    }
        //}
    }
}
