﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Text;
using System.Text.Json.Serialization;
using System.Threading.Tasks;

namespace FlexGridIntro.Shared
{
    public class Customers
    {
        [Required]
        public int CustomerKey { get; set; }
        [Required]
        [StringLength(10,ErrorMessage ="Name cannot be more than 10 char.")]
        public string? Customer { get; set; }
        public string? Link { get; set; } = "http://google.co.in";
        public string? BillToCustomer { get; set; }
        public string? Category { get; set; }
        public string? BuyingGroup { get; set; }
        public string? PrimaryContact { get; set; }
        public string? PostalCode { get; set; }
        public DateTime ValidFrom { get; set; }
        public DateTime ValidTo { get; set; }

        public bool IsDeleted { get; set; }
        public Double? Sales { get; set; }
        public static IEnumerable<Customers> GetCustomers(int Count)
        {
            var _names = "Alex,Bob,Bobby, Booker, Bowie,Chris,David,Evan,Freddy,George,Henry,Isac,Jack,Ken,Laurie".Split(",");
            var _buyingGroups = ",WJ,SP,C1,AR,".Split(",");
            var _categories = "Platinum,Standard".Split(",");
            var _random = new Random();
            var data = new List<Customers>();
            for (int i = 0; i < Count; i++)
            {
                var _rnd = _random.Next();
                data.Add(new Customers()
                {
                    BillToCustomer = _names[i % _names.Length],
                    BuyingGroup = _buyingGroups[_rnd % _buyingGroups.Length],
                    PrimaryContact = _names[i % _names.Length],
                    Category = _categories[_rnd % _categories.Length],
                    Customer = _names[i % _names.Length],
                    CustomerKey = i,
                    PostalCode = (_rnd % 99999).ToString(),
                    ValidFrom = DateTime.Now.AddDays(i),
                    ValidTo = DateTime.Now.AddYears(i % 2),
                    IsDeleted = i% 2==0,
                    Sales = _random.NextDouble() * 10000,
                });
                if(i > 3 )
                {
                    data[i].Link = (i % 3 == 0) ? null : "";
                }
            }
            //Thread.Sleep(2000); // simulate network delay 
            return data;


        }
    }
    public class TResponse<T> where T:class
    {
        public int TotalCount { get; set; }
        public IEnumerable<T> Responses { get; set; }
    }
    public class CustomerResponse
    {
        public int TotalCount { get; set; }
        public IEnumerable<Customers> Customers { get; set; }
    }
}
